User's Guide
Reference Manual
Release Notes
PDF
Top

Dialyzer
Reference Manual
Version 2.6.1

Expand All
Contract All

Table of Contents

# dialyzer

### MODULE

dialyzer

### MODULE SUMMARY

The Dialyzer, a DIscrepancy AnalYZer for ERlang programs

### DESCRIPTION

The Dialyzer is a static analysis tool that identifies software discrepancies such as definite type errors, code which has become dead or unreachable due to some programming error, unnecessary tests, etc. in single Erlang modules or entire (sets of) applications. Dialyzer starts its analysis from either debug-compiled BEAM bytecode or from Erlang source code. The file and line number of a discrepancy is reported along with an indication of what the discrepancy is about. Dialyzer bases its analysis on the concept of success typings which allows for sound warnings (no false positives).

Read more about Dialyzer and about how to use it from the GUI in Dialyzer User's Guide.

### Using the Dialyzer from the command line

Dialyzer also has a command line version for automated use. Below is a brief description of the list of its options. The same information can be obtained by writing

          dialyzer --help

in a shell. Please refer to the GUI description for more details on the operation of Dialyzer.

The exit status of the command line version is:

          0 - No problems were encountered during the analysis and no
              warnings were emitted.
          1 - Problems were encountered during the analysis.
          2 - No problems were encountered, but warnings were emitted.

Usage:

           dialyzer [--help] [--version] [--shell] [--quiet] [--verbose]
    		[-pa dir]* [--plt plt] [--plts plt*] [-Ddefine]*
                    [-I include_dir]* [--output_plt file] [-Wwarn]*
                    [--src] [--gui | --wx] [files_or_dirs] [-r dirs]
                    [--apps applications] [-o outfile]
    		[--build_plt] [--add_to_plt] [--remove_from_plt]
    		[--check_plt] [--no_check_plt] [--plt_info] [--get_warnings]
                    [--no_native] [--fullpath]

Options:

files_or_dirs (for backwards compatibility also as: -c files_or_dirs
  Use Dialyzer from the command line to detect defects in the specified files or directories containing .erl or .beam files, depending on the type of the analysis.
-r dirs
  Same as the previous but the specified directories are searched recursively for subdirectories containing .erl or .beam files in them, depending on the type of analysis.
--apps applications
  Option typically used when building or modifying a plt as in:

                 dialyzer --build_plt --apps erts kernel stdlib mnesia ...

  to conveniently refer to library applications corresponding to the Erlang/OTP installation. However, the option is general and can also be used during analysis in order to refer to Erlang/OTP applications. In addition, file or directory names can also be included, as in:

                 dialyzer --apps inets ssl ./ebin ../other_lib/ebin/my_module.beam

-o outfile (or --output outfile)
  When using Dialyzer from the command line, send the analysis results to the specified outfile rather than to stdout.
--raw
  When using Dialyzer from the command line, output the raw analysis results (Erlang terms) instead of the formatted result. The raw format is easier to post-process (for instance, to filter warnings or to output HTML pages).
--src
  Override the default, which is to analyze BEAM files, and analyze starting from Erlang source code instead.
-Dname (or -Dname=value)
  When analyzing from source, pass the define to Dialyzer. (**)
-I include_dir
  When analyzing from source, pass the include_dir to Dialyzer. (**)
-pa dir
  Include dir in the path for Erlang (useful when analyzing files that have '-include_lib()' directives).
--output_plt file
  Store the plt at the specified file after building it.
--plt plt
  Use the specified plt as the initial plt (if the plt was built during setup the files will be checked for consistency).
--plts plt*
  Merge the specified plts to create the initial plt -- requires that the plts are disjoint (i.e., do not have any module appearing in more than one plt). The plts are created in the usual way:

                 dialyzer --build_plt --output_plt plt_1 files_to_include
                 ...
                 dialyzer --build_plt --output_plt plt_n files_to_include

  and then can be used in either of the following ways:

                 dialyzer files_to_analyze --plts plt_1 ... plt_n

  or:

                 dialyzer --plts plt_1 ... plt_n -- files_to_analyze

  (Note the -- delimiter in the second case)
-Wwarn
  A family of options which selectively turn on/off warnings (for help on the names of warnings use dialyzer -Whelp).
--shell
  Do not disable the Erlang shell while running the GUI.
--version (or -v)
  Print the Dialyzer version and some more information and exit.
--help (or -h)
  Print this message and exit.
--quiet (or -q)
  Make Dialyzer a bit more quiet.
--verbose
  Make Dialyzer a bit more verbose.
--statistics
  Prints information about the progress of execution (analysis phases, time spent in each and size of the relative input).
--build_plt
  The analysis starts from an empty plt and creates a new one from the files specified with -c and -r. Only works for beam files. Use --plt or --output_plt to override the default plt location.
--add_to_plt
  The plt is extended to also include the files specified with -c and -r. Use --plt to specify which plt to start from, and --output_plt to specify where to put the plt. Note that the analysis might include files from the plt if they depend on the new files. This option only works with beam files.
--remove_from_plt
  The information from the files specified with -c and -r is removed from the plt. Note that this may cause a re-analysis of the remaining dependent files.
--check_plt
  Check the plt for consistency and rebuild it if it is not up-to-date.
--no_check_plt
  Skip the plt check when running Dialyzer. Useful when working with installed plts that never change.
--plt_info
  Make Dialyzer print information about the plt and then quit. The plt can be specified with --plt(s).
--get_warnings
  Make Dialyzer emit warnings even when manipulating the plt. Warnings are only emitted for files that are actually analyzed.
--dump_callgraph file
  Dump the call graph into the specified file whose format is determined by the file name extension. Supported extensions are: raw, dot, and ps. If something else is used as file name extension, default format '.raw' will be used.
--no_native (or -nn)
  Bypass the native code compilation of some key files that Dialyzer heuristically performs when dialyzing many files; this avoids the compilation time but it may result in (much) longer analysis time.
--fullpath
  Display the full path names of files for which warnings are emitted.
--gui
  Use the gs-based GUI.
--wx
  Use the wx-based GUI.

Note

* denotes that multiple occurrences of these options are possible.

** options -D and -I work both from command-line and in the Dialyzer GUI; the syntax of defines and includes is the same as that used by erlc.

Warning options:

-Wno_return
  Suppress warnings for functions that will never return a value.
-Wno_unused
  Suppress warnings for unused functions.
-Wno_improper_lists
  Suppress warnings for construction of improper lists.
-Wno_tuple_as_fun
  Suppress warnings for using tuples instead of funs.
-Wno_fun_app
  Suppress warnings for fun applications that will fail.
-Wno_match
  Suppress warnings for patterns that are unused or cannot match.
-Wno_opaque
  Suppress warnings for violations of opaqueness of data types.
-Wno_behaviours***
  Suppress warnings about behaviour callbacks which drift from the published recommended interfaces.
-Wunmatched_returns***
  Include warnings for function calls which ignore a structured return value or do not match against one of many possible return value(s).
-Werror_handling***
  Include warnings for functions that only return by means of an exception.
-Wrace_conditions***
  Include warnings for possible race conditions.
-Wunderspecs***
  Warn about underspecified functions (the -spec is strictly more allowing than the success typing).

The following options are also available but their use is not recommended: (they are mostly for Dialyzer developers and internal debugging)

-Woverspecs***
  Warn about overspecified functions (the -spec is strictly less allowing than the success typing).
-Wspecdiffs***
  Warn when the -spec is different than the success typing.

Note

*** Identifies options that turn on warnings rather than turning them off.

### Using the Dialyzer from Erlang

You can also use Dialyzer directly from Erlang. Both the GUI and the command line versions are available. The options are similar to the ones given from the command line, so please refer to the sections above for a description of these.

### EXPORTS

gui() -> ok | {error, Msg}
gui(OptList) -> ok | {error, Msg}

Types:

OptList -- see below

Dialyzer GUI version.

    OptList  :: [Option]
    Option   :: {files,          [Filename :: string()]}
              | {files_rec,      [DirName :: string()]}
              | {defines,        [{Macro: atom(), Value : term()}]}
              | {from,           src_code | byte_code} %% Defaults to byte_code
              | {init_plt,       FileName :: string()}  %% If changed from default
              | {plts,           [FileName :: string()]} %% If changed from default
              | {include_dirs,   [DirName :: string()]}
              | {output_file,    FileName :: string()}
              | {output_plt,     FileName :: string()}
              | {analysis_type,  'succ_typings' |
                                 'plt_add' |
                                 'plt_build' |
                                 'plt_check' |
                                 'plt_remove'}
              | {warnings,       [WarnOpts]}
              | {get_warnings,   bool()}

    WarnOpts :: no_return
              | no_unused
              | no_improper_lists
              | no_fun_app
              | no_match
              | no_opaque
              | no_fail_call
              | error_handling
              | race_conditions
              | behaviours
              | unmatched_returns
              | overspecs
              | underspecs
              | specdiffs

run(OptList) -> Warnings

Types:

OptList -- see gui/0,1
Warnings -- see below

Dialyzer command line version.

    Warnings :: [{Tag, Id, Msg}]
    Tag :: 'warn_return_no_exit' | 'warn_return_only_exit'
         | 'warn_not_called' | 'warn_non_proper_list'
         | 'warn_fun_app' | 'warn_matching'
         | 'warn_failing_call' | 'warn_contract_types'
         | 'warn_contract_syntax' | 'warn_contract_not_equal'
         | 'warn_contract_subtype' | 'warn_contract_supertype'
    Id = {File :: string(), Line :: integer()}
    Msg = msg() -- Undefined

format_warning(Msg) -> string()

Types:

Msg = {Tag, Id, msg()} -- See run/1

Get a string from warnings as returned by dialyzer:run/1.

plt_info(string()) -> {'ok', [{atom(), any()}]} | {'error', atom()}

Returns information about the specified plt.